      SUBROUTINE DET1(NNRM,NM,EMX,PMX,AMX,
     1 IJP,NIJP,IJQ,NIJQ,FAS,F,FDET,IFAIL,VERM)
C
C  CALCULATES DETA OR THE PRODUCT OF THE SUBDETERMINANTS AS A
C  FUNCTION OF THE INDEPENDENT VARIABLES IN FAS.
C  NNRM: NUMBER OF SUBDETERMINANTS = INPUT
C  NM: ORDER OF ANY DETERMINANT = INPUT
C  EMX(NM,NM,NNRM) MODULI OF THE MATRIX ELEMENTS = INPUT
C  PMX(NM,NM,NNRM) PHASES OF THE MATRIX ELEMENTS IN RADIANS
C  AMX(NM,NM,NNRM) =INPUT
C  IJP(NIJP) =INPUT, SEE SUBR MMTRX
C  FAS(NIJP) =INPUT, THE INDEPENDENT PHASES
C  FDET(NNRM) =OUTPUT, INDIVIDUAL DETERMINANT VALUES
C  IFAIL: SEE INFO ZPOTRF.F 
C
      DIMENSION EMX(NM,NM,NNRM)
      DIMENSION PMX(NM,NM,NNRM)
      REAL*8 VERM,FM,F,FDET
      COMPLEX*16 AMX(NM,NM,NNRM)
      DIMENSION FDET(NNRM)
      DIMENSION IJP(7,NIJP),IJQ(8,NIJQ)
      DIMENSION FAS(NIJP)
      CHARACTER UPLO
C
C  STORE INPUT PHASES IN THE MATRICES
C
      IF(NIJP.GT.0)
     1 CALL VULLER(NNRM,PMX,NM,IJP,NIJP,IJQ,NIJQ,FAS)
      CALL VULAMX(EMX,PMX,AMX,NM,NNRM,VERM)
C
C  CHOLESKY DECOMPOSITION
C
      UPLO='L'
      F=1.0D0
      DO 150 MA=1,NNRM
      FM=1.0D0
      CALL ZPOTRF(UPLO,NM,AMX(1,1,MA),NM,IFAIL)
      IF(IFAIL.NE.0) THEN
      IFAIL=MA
      F=0.0
      GOTO 999
      ELSE
      DO 190 I=1,NM  
      FM=FM*DREAL(AMX(I,I,MA))
  190 CONTINUE
      FM=FM*FM
      FDET(MA)=FM
C
C  INSTEAD OF THE PRODUCT THE GEOMETRIC MEAN IS TAKEN
C  OF THE INDIVIDUAL SUBDETERMINANTS
C  THIS IS THE SAME AS THE N-TH ROOT OF THE PRODUCT
C
      IF(MA.GT.1)THEN
      F=F*(FM/F)**(1.0/FLOAT(MA))
      ELSE
      F=FM
      ENDIF
      ENDIF
  150 CONTINUE
  999 CONTINUE
      RETURN
      END
