      SUBROUTINE JAAP1(AMX,IJP,NIJP,
     1 IJQ,NIJQ,NNRM,NM,GC,FDET)
C
C  CALCULATES DBETA/DALPHA (SEE PAPER)
C  ON EXIT AMX CONTAINS THE INVERSE OF THE KH MATRICES (SEE ZPOTRI, LAPACK)
C  GC CONTAINS THE GRADIENTS
C
      COMPLEX*16 AMX(NM,NM,NNRM)
      REAL*8 FDET(NNRM),GC,AABS,BABS
      DIMENSION IJP(7,NIJP)
      DIMENSION IJQ(8,NIJQ)
      DIMENSION GC(NIJP)
      CHARACTER UPLO
C
C  INVERT THE MATRICES
C
      UPLO='L'
      DO 50 MA=1,NNRM
      CALL ZPOTRI(UPLO,NM,AMX(1,1,MA),NM,IFAIL)
      CALL FASCOM(AMX(1,1,MA),AMX(1,1,MA),NM,NM)
   50 CONTINUE
      DO 100 I=1,NIJP
C
C  GET ROW AND COLUMN OF VARIABLE I
C
C     WRITE(6,*)(IJP(KK,I),KK=1,7)
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      IMA=IJP(3,I)
C
C  GET PHASE AND MODULUS
C
      AABS=DREAL(AMX(IRY,IKO,IMA))
      BABS=DREAL(AMX(IKO,IRY,IMA))
      ALPHA=DIMAG(AMX(IRY,IKO,IMA))
      BETA=-DIMAG(AMX(IKO,IRY,IMA))
      GC(I)=-2.0*AABS*BABS*SIN(BETA-ALPHA)*FDET(IMA)
C
C  GET SYMMETRY DEPENDENTS CONTRIBUTING IF ANY
C
      IEI=IJP(5,I)
      IF(IEI.NE.0)THEN
      IBE=IJP(4,I)
      DO 90 J=IBE,IEI
C     WRite(6,*)(IJQ(kkk,J),KKK=1,8)
      IRY=IJQ(1,J)
      IKO=IJQ(2,J)
      IMA=IJQ(3,J)
C
C  ADD SYMMETRY DEPENDENTS CONTRIBUTION WITH CORRECT SIGN
C
      IT=IJQ(8,J)
      AABS=DREAL(AMX(IRY,IKO,IMA))
      BABS=DREAL(AMX(IKO,IRY,IMA))
      ALPHA=IMAG(AMX(IRY,IKO,IMA))
      BETA=-IMAG(AMX(IKO,IRY,IMA))
      GC(I)=GC(I)-2.0*AABS*BABS*SIN(BETA-ALPHA)*(1-2*IT)*FDET(IMA)
   90 CONTINUE
      ENDIF
C     GC(I)=GC(I)*FDET/NNRM
C     Write(6,*)'Ik heb de gradient: ',GC(I)
  100 CONTINUE
      RETURN
      END
