      SUBROUTINE OPDETI(NNRM,NM,EMX,GEW,IJP,NIJP,IJQ,NIJQ
     1 ,IJPA,IJQA,NFS,NIJQA,ICYCMX,ELIM,IREF,IWGHT,GLIM,IFAS,NREFTY
     2 ,NHKLF)
C
C  NNRM DETERMINANTS ARE MAXIMIZED CONCURRENTLY
C  ONLY THE PHASES IN COLUMNS MMX(I) TO NMX(I) ARE CHANGED
C
C  PARAMETERS
C
C  NM = INPUT = ORDER OF SUBDETERMINANT
C
C  NNRM = INPUT =
C
C  NHKLF = INPUT =
C  =1 INPUT REFLECTION FILE CONTAINS PHASE INFORMATION
C  =0 AB INITIO PHASING
C
C  EMX(NM,NM,NNRM) = INPUT =
C  E-VALUES IN THE LOWER TRIANGLE
C
C  GEW(NM,NM,NNRM) = INPUT =
C  WEIGHTS OF SIR, MIR OR ANY OTHER PHASES
C
C  IJP,IJQ = INPUT = SEE MMTRX
C  IJPA,IJQA = OUTPUT = CONTAINS VARIABLES FOR OPDET
C  NFS  = OUTPUT = NUMBER OF VARIABLES
C  NIJQA = OUTPUT = NUMBER OF RELATIONS
C
C  ELIM = INPUT = REFLEXIONS WITH E<ELIM ARE SET TO ZERO
C
C  IREF = INPUT =
C  =1 KNOWN REFLECTIONS ARE REFINED
C  =0 KNOWN REFLECTIONS FIXED
C
C  IWGHT = THE ARRAY GEW CONTAINS WEIGHTS IF IWGHT=1
C
C  GLIM = INPUT = REFLECTIONS WITH WEIGHTS>GLIM ARE NOT REFINED
C
      INTEGER HMAX
      LOGICAL ENUL,REFINE
      DIMENSION EMX(NM,NM,NNRM)
      DIMENSION GEW(NM,NM,NNRM)
      DIMENSION IJP(7,NIJP),IJPA(7,NIJP),IJQ(8,NIJQ),
     1 IJQA(8,NIJQ)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
C
C  IJPA AND IJQA ARE INITIALIZED. ONLY THE INFORMATION
C  PERTAINING TO THE REFLEXIONS TO BE REFINED IS USED
C
      NIJPA=0
      NIJQA=0
      DO 50 I=1,NIJP
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      MA=IJP(3,I)
      IBE=IJP(4,I)
      IEI=IJP(5,I)
      MK=IJP(6,I)
C     Write(6,1235)I,IRY,IKO,MA,EMX(IRY,IKO,MA),IBE,IEI
C235  Format(' Nummer, rij, kolom, matrix E,',4I3,E12.4,2I3)
      ENUL=EMX(IRY,IKO,MA).GT.ELIM
      IF(.NOT.ENUL)EMX(IRY,IKO,MA)=0.0
C
C  SKIP IJP IF REFLEXIONS ARE NOT TO BE REFINED
C
      REFINE=NREFTY.EQ.1.OR.IFAS.EQ.0.OR.IJP(7,I).NE.3
      REFINE=REFINE.AND.ENUL
      REFINE=REFINE.AND.(IREF.EQ.1.OR.NHKLF.EQ.0)
      REFINE=REFINE.AND.(NHKLF.EQ.0.OR.GEW(IRY,IKO,MA).LT.GLIM)
C     Write(6,*)REFINE
      IF(REFINE)THEN
C     Write(6,1244)(IJP(L,I),L=1,7)
C244  Format(' ',7I3)
      NIJPA=NIJPA+1
      IBEA=NIJQA+1
      DO 551 L=1,7
  551 IJPA(L,NIJPA)=IJP(L,I)
C     Write(6,1243)
C243  Format(' IJP gekopieerd')
      IF(IEI.GT.0)THEN
      IJPA(4,NIJPA)=IBEA
      IJPA(5,NIJPA)=IBEA+IEI-IBE
      DO 30 J=IBE,IEI
C
C  COPY RELEVANT RELATIONS IN IJQA
C
C     IRY=IJQ(1,J)
C     IKO=IJQ(2,J)
C     MA=IJQ(3,J)
C     IF(IRY.GT.NMX(MA).OR.IRY.LT.MMX(MA)) GOTO 30
      NIJQA=NIJQA+1
      DO 570 L=1,8
      IJQA(L,NIJQA)=IJQ(L,J)
  570 CONTINUE
   30 CONTINUE
      ENDIF
      ELSE
      IF(IEI.GT.0.AND.(.NOT.ENUL))THEN
C     Write(6,1240)
C240  Format(' Ik hem nul maken')
      DO 31 J=IBE,IEI
C
C  ZERO E's IF REQUIRED
C
      IRY=IJQ(1,J)
      IKO=IJQ(2,J)
      MA=IJQ(3,J)
      EMX(IRY,IKO,MA)=0.0
   31 CONTINUE
      ENDIF
      ENDIF
   50 CONTINUE
C
C  NUMBER OF INDEPENDENT VARIABLES
C
      NFS=NIJPA
C
C  MAXIMUM NUMBER OF ITERATIONS
C
      NFS2=2*NFS
      ICYCMX=MAX0(NFS2,10)
C     ICYCMX=MAX0(NFS,10)
C      ICYCMX=5
      E0=EMX(1,1,1)
C
C  NORMALIZE E'S
C
      DO 100 MA=1,NNRM
      DO 100 I=1,NM
      DO 100 J=1,I
      IF(EMX(I,J,MA).GT.0.001)THEN
      EMX(I,J,MA)=EMX(I,J,MA)/E0
      ENDIF
  100 CONTINUE
      IF(NFS.EQ.0)THEN
      WRITE(LO,13)
   13 FORMAT(' OPDETI: NO PHASES ARE REFINED')
      ELSE
      WRITE(LO,14)NFS
14    FORMAT(' OPDETI: ',I5,' PHASES ARE REFINED')
      ENDIF
      RETURN
      END
