      SUBROUTINE TEOFS(X,NATOM,PMX,EMX,MX,NM,NNRM,IJP,NIJP,IJQ,
     1 NIJQ,IN,LO)
C
C  PUTS CALCULATED PHASES IN PMX
C  READS NATOM ATOMS OF FILE "IN" IN FREE FORMAT
C  ATOP: MULTIPLICITY*ATOMNUMBER, X, Y, Z
C  X: WORKSPACE
C  NATOM: NUMBER OF ATOMS
C
      INTEGER H(3)
      INTEGER HKL
      DIMENSION X(4,NATOM),PMX(NM,NM,NNRM),EMX(NM,NM,NNRM),
     1 MX(NM,NNRM),IJP(7,NIJP),IJQ(8,NIJQ)
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /DETPAR/ E000,EONOB1,EONOB2,NDIM1,NDIM2
      M128=8421504
      TWOPI=2.0*3.14159265
C
C  READ ATOMPARAMETERS
C
      NTOM=1
  500 READ(IN,*,END=1000) X(1,NTOM),X(2,NTOM),X(3,NTOM),X(4,NTOM)
      NTOM=NTOM+1
      IF(NTOM.GT.NATOM) GOTO 1000
      GOTO 500
 1000 CONTINUE
      NTOM=NTOM-1
      NATOM=NTOM
	IF(NTOM.GT.0)THEN
      WRITE(LO,1) NATOM
    1 FORMAT(' NUMBER OF ATOMS:',I5)
      WRITE(LO,2)
    2 FORMAT(1H ,3('NR*MULT  X      Y      Z  '),/)
      WRITE(LO,3) ((X(J,I),J=1,4),I=1,NATOM)
    3 FORMAT(3(1X,F4.1,3F7.3))
C
C  LOOP OVER INDEPENDENT PHASES
      DO 100 I=1,NIJP
C
C  GET HKL
C
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      IMA=IJP(3,I)
      HKL=M128+MX(IKO,IMA)-MX(IRY,IMA)
      CALL UNPK1(HKL,H(1),H(2),H(3))
C
C  A=REAL, B=IMAGINARY
C
      A=0.0
      B=0.0
C
C  LOOP OVER ATOMS
C
      DO 90 J=1,NATOM
C
C  LOOP OVER SYMMETRY OPERATIONS
C
      DO 80 K=1,NSYM
      ARG=0.0
      DO 70 L=1,3
      XX=0.0
      DO 60 LL=1,2
      M=IABS(IS(LL,L,K))
      IF(M.NE.0) XX=XX+X(1+M,J)*ISIGN(1,IS(LL,L,K))+TS(L,K)
   60 CONTINUE
      ARG=ARG+H(L)*XX
   70 CONTINUE
      ARG=TWOPI*ARG
      A=A+X(1,J)*COS(ARG)
      B=B+X(1,J)*SIN(ARG)
   80 CONTINUE
   90 CONTINUE
C
      W=0.0
      IF(A.NE.0.0.OR.B.NE.0.0) W=ATAN2(B,A)
       E=EMX(IRY,IKO,IMA)*E000
       IF(E.GT.1.5)THEN
       WRITE(6,1234) H,A,B,E,W*180.0/3.14159265
 1234  FORMAT(3I4,3E10.3,F6.1)
       ENDIF
      W=AMOD(W,TWOPI)
      PMX(IRY,IKO,IMA)=W
  	PMX(IKO,IRY,IMA)=-W
  100 CONTINUE
C
C  IMPLEMENT SYMMETRY RELATIONS
C
      CALL VERBA(NNRM,PMX,NM,IJQ,NIJQ)
	ENDIF
      RETURN
      END
