	program mkautf
C
C  Make the file autofour.cdat from the file autofour.asc (fort.36) 
C  which is present in the directory drivers.
C  The file autofour.asc contains the recommended values for the 
C  input to the program Deter.
C  Deter.use (fort.37) has the same format as autofour.asc. 
C  The user may use this file to overide the values of specific 
C  parameters given in autofour.asc.
C  In autofour.use only the values to be changed need be given.
C
	Dimension Key(100),Ivar(100),KV(2),NUM(10)
	Character Key*6,Regel*80,Word*6,upper*80,Eind*6,Title*80,trim*80
C
C  Read *.aut file
C    
	Eind='END   '
	Eind=trim(Eind)
      READ(38,101)Title
      READ(38,104)CEN,IFOUR1,IFOUR2,NCCH,NAT,ITT,PERC,DELR,
     1 STOPR,DN,PRW
	READ(38,102)NUM,NLEES,IECK,NWEG,METHOD,IWEIGH,IVAL
	READ(38,103)BOV,SCALE,ISTML,IDRMPL,NDIF,IBLES
100	Format(A6,I4)
101   Format(A80)
104   Format(4X,A1,5I5,5F10.2)
102   Format(16I5)
103	Format(2F10.3,12I5)
C
C  Read autofour.asc
C
	Do 40 I=1,14
	Read(36,100)Key(I),Ivar(I)
	Key(i)=trim(key(i))
40	Continue
	ivar(15)=0
	key(15)=Eind
	Do 41 I=16,100
	Ivar(I)=0
	Key(I)=' '
41	Continue
10	Continue
C
C  Now read changes requested by the user
C
	Read(37,101,End=200)Regel
	Word=trim(Regel)
	Word=upper(Word)
	IF(Word.eq.Eind)goto 200
	Do 30 I=1,15
	If(Word.EQ.Key(I))Then
	Kvar=val(Regel)
	Ivar(I)=Kvar
	Go To 10
	Endif
30	Continue
C
C  Error in code given by the user
C
	Write(39,201)0
201	Format(I1)
	Stop'Error in inputfile to Autofour'
200	Continue
	Write(39,201)1
C
C  Write output on 40, this will be the file *.aut
C
	IFOUR1=Ivar(1)
	IFOUR2=Ivar(2)
	PERC=Ivar(3)/10.0
	NCCH=Ivar(4)
	DELR=Ivar(5)/10.0
	STOPR=Ivar(6)/100.0
	DN=Ivar(7)/10.0
	PRW=Ivar(8)/10.0
	NLEES=Ivar(9)
	NWEG=Ivar(10)
	METHOD=IVAR(11)
	IWEIGH=IVAR(12)
	IVAL=IVAR(13)
	IBLES=IVAR(14)
      WRITE(40,101)Title
      WRITE(40,104)CEN,IFOUR1,IFOUR2,NCCH,NAT,ITT,PERC,DELR,
     1 STOPR,DN,PRW
	WRITE(40,102)NUM,NLEES,IECK,NWEG,METHOD,IWEIGH,IVAL
	WRITE(40,103)BOV,SCALE,ISTML,IDRMPL,NDIF,IBLES
	End
      character*80 function upper(string)
      character*100 up,down
      character*(*) string
      character*80 onder
      character a
      UP  ='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      DOWN='abcdefghijklmnopqrstuvwxyz'
      onder=string
      lengte=len(string)
      Do 1 i=1,lengte
      a=onder(i:i)
      Do 2 j=1,26
      if(a.eq.down(j:j))then
      a=up(j:j)
      goto 3
      endif
2     continue
3     onder(i:i)=a
1     continue
      upper=onder
      RETURN
      END
      real function val(st)
      character*(*) st
      character a
      logical*4 se,sm,ep,re,bg
      integer*4 ch,iex,les,i,man,irest,jex
c     init
      sm=.false.
      EP=.FALSE.
      SE=.false.
      RE=.false.
	bg=.false.
      IEX=0
      JEX=1
      EX=1.0D0
      MAN=0
      IREST=0
      LES=LEN(ST)
      I=0
 10   I=I+1
      a=st(I:I)
      CH=ICHAR(a)
	if(bg.or.(ch.ge.43.and.ch.le.57.and.ch.ne.44.and.ch.ne.47))then
	bg=.true.
      if((CH.EQ.43).OR.(CH.EQ.45)) THEN
      if(.not.ep)Then
c-----sign mantisse
                IF(CH.EQ.45) SM=.TRUE.           ! +
                IF(CH.EQ.43) SM=.FALSE.          ! -
      Else
c-----sign exponent
                IF(CH.EQ.45) SE=.TRUE.
                IF(CH.EQ.43) SE=.FALSE.
      endif
      Elseif(ch.eq.46)Then
      re=.true.
      ELSEIF((CH.GE.48).AND.(CH.LE.57)) THEN     !0< CH < 9
      if(.not.ep)Then
      if(.not.re)Then
C-----MANTISSE
      MAN=MAN*10+CH-48
      Else
C-----mantisse achter de komma
      jex=jex*10
      irest=irest*10+ch-48
      endif
      Else
c-----exponent
      iex=iex*10+ch-48
      endif
      Elseif(ch.eq.69.or.ch.eq.101.or.ch.eq.68.or.ch.eq.100)Then  !d,e,D
C     EXPONENT
      ep=.true.
      endif
	endif
      If(i.lt.les)goto 10
      tisse=MAN+IREST/float(JEX)
      IF(EP) THEN
        EX=10.0**IEX
        IF (SE) EX=1.0/EX
      ENDIF
      tisse=tisse*ex
      IF(SM)tisse=-tisse
      val=tisse
      Return
      end
	character*80 function trim(string)
	character*80 h
	character*(*) string
	character a,b
	b=' '
	l=len(string)
	ibegin=0
	ieind=l
	do 1 i=1,l
	a=string(i:i)
	if(ibegin.eq.0)then
	if(a.ne.b)then  
	ibegin=i
	endif
	else
	if(a.eq.b)then
	ieind=i-1
	goto 2
	endif
	endif
1	Continue
2	Continue
	i=7      
	Do 3 j=ieind,ibegin,-1
	i=i-1
	h(i:i)=string(j:j)
3	continue
	ib=i
	do 4 j=7,80
	h(j:j)=b
4	continue
	if(ib.ne.1)then
	do 5 j=1,ib-1
	h(j:j)=b
5	continue
	endif
	trim=h
	return
	end
